/* Copyright 2014 Adobe Systems Incorporated (http://www.adobe.com/). All Rights Reserved.
   This software is licensed as OpenSource, under the Apache License, Version 2.0.
   This license is available at: http://opensource.org/licenses/Apache-2.0. */

/*
 * Standard Apple Glyph Ordering (258 entries) aggregate initializer.
 * https://developer.apple.com/fonts/TrueType-Reference-Manual/RM06/Chap6post.html
 *
 * Elements values are glyph names. Index by glyph index (GID) get glyph name.
 */

    /* 000 */   ".notdef",
    /* 001 */   ".null",
    /* 002 */   "nonmarkingreturn",
    /* 003 */   "space",
    /* 004 */   "exclam",
    /* 005 */   "quotedbl",
    /* 006 */   "numbersign",
    /* 007 */   "dollar",
    /* 008 */   "percent",
    /* 009 */   "ampersand",
    /* 010 */   "quotesingle",
    /* 011 */   "parenleft",
    /* 012 */   "parenright",
    /* 013 */   "asterisk",
    /* 014 */   "plus",
    /* 015 */   "comma",
    /* 016 */   "hyphen",
    /* 017 */   "period",
    /* 018 */   "slash",
    /* 019 */   "zero",
    /* 020 */   "one",
    /* 021 */   "two",
    /* 022 */   "three",
    /* 023 */   "four",
    /* 024 */   "five",
    /* 025 */   "six",
    /* 026 */   "seven",
    /* 027 */   "eight",
    /* 028 */   "nine",
    /* 029 */   "colon",
    /* 030 */   "semicolon",
    /* 031 */   "less",
    /* 032 */   "equal",
    /* 033 */   "greater",
    /* 034 */   "question",
    /* 035 */   "at",
    /* 036 */   "A",
    /* 037 */   "B",
    /* 038 */   "C",
    /* 039 */   "D",
    /* 040 */   "E",
    /* 041 */   "F",
    /* 042 */   "G",
    /* 043 */   "H",
    /* 044 */   "I",
    /* 045 */   "J",
    /* 046 */   "K",
    /* 047 */   "L",
    /* 048 */   "M",
    /* 049 */   "N",
    /* 050 */   "O",
    /* 051 */   "P",
    /* 052 */   "Q",
    /* 053 */   "R",
    /* 054 */   "S",
    /* 055 */   "T",
    /* 056 */   "U",
    /* 057 */   "V",
    /* 058 */   "W",
    /* 059 */   "X",
    /* 060 */   "Y",
    /* 061 */   "Z",
    /* 062 */   "bracketleft",
    /* 063 */   "backslash",
    /* 064 */   "bracketright",
    /* 065 */   "asciicircum",
    /* 066 */   "underscore",
    /* 067 */   "grave",
    /* 068 */   "a",
    /* 069 */   "b",
    /* 070 */   "c",
    /* 071 */   "d",
    /* 072 */   "e",
    /* 073 */   "f",
    /* 074 */   "g",
    /* 075 */   "h",
    /* 076 */   "i",
    /* 077 */   "j",
    /* 078 */   "k",
    /* 079 */   "l",
    /* 080 */   "m",
    /* 081 */   "n",
    /* 082 */   "o",
    /* 083 */   "p",
    /* 084 */   "q",
    /* 085 */   "r",
    /* 086 */   "s",
    /* 087 */   "t",
    /* 088 */   "u",
    /* 089 */   "v",
    /* 090 */   "w",
    /* 091 */   "x",
    /* 092 */   "y",
    /* 093 */   "z",
    /* 094 */   "braceleft",
    /* 095 */   "bar",
    /* 096 */   "braceright",
    /* 097 */   "asciitilde",
    /* 098 */   "Adieresis",
    /* 099 */   "Aring",
    /* 100 */   "Ccedilla",
    /* 101 */   "Eacute",
    /* 102 */   "Ntilde",
    /* 103 */   "Odieresis",
    /* 104 */   "Udieresis",
    /* 105 */   "aacute",
    /* 106 */   "agrave",
    /* 107 */   "acircumflex",
    /* 108 */   "adieresis",
    /* 109 */   "atilde",
    /* 110 */   "aring",
    /* 111 */   "ccedilla",
    /* 112 */   "eacute",
    /* 113 */   "egrave",
    /* 114 */   "ecircumflex",
    /* 115 */   "edieresis",
    /* 116 */   "iacute",
    /* 117 */   "igrave",
    /* 118 */   "icircumflex",
    /* 119 */   "idieresis",
    /* 120 */   "ntilde",
    /* 121 */   "oacute",
    /* 122 */   "ograve",
    /* 123 */   "ocircumflex",
    /* 124 */   "odieresis",
    /* 125 */   "otilde",
    /* 126 */   "uacute",
    /* 127 */   "ugrave",
    /* 128 */   "ucircumflex",
    /* 129 */   "udieresis",
    /* 130 */   "dagger",
    /* 131 */   "degree",
    /* 132 */   "cent",
    /* 133 */   "sterling",
    /* 134 */   "section",
    /* 135 */   "bullet",
    /* 136 */   "paragraph",
    /* 137 */   "germandbls",
    /* 138 */   "registered",
    /* 139 */   "copyright",
    /* 140 */   "trademark",
    /* 141 */   "acute",
    /* 142 */   "dieresis",
    /* 143 */   "notequal",
    /* 144 */   "AE",
    /* 145 */   "Oslash",
    /* 146 */   "infinity",
    /* 147 */   "plusminus",
    /* 148 */   "lessequal",
    /* 149 */   "greaterequal",
    /* 150 */   "yen",
    /* 151 */   "mu",
    /* 152 */   "partialdiff",
    /* 153 */   "summation",
    /* 154 */   "product",
    /* 155 */   "pi",
    /* 156 */   "integral",
    /* 157 */   "ordfeminine",
    /* 158 */   "ordmasculine",
    /* 159 */   "Omega",
    /* 160 */   "ae",
    /* 161 */   "oslash",
    /* 162 */   "questiondown",
    /* 163 */   "exclamdown",
    /* 164 */   "logicalnot",
    /* 165 */   "radical",
    /* 166 */   "florin",
    /* 167 */   "approxequal",
    /* 168 */   "Delta",
    /* 169 */   "guillemotleft",
    /* 170 */   "guillemotright",
    /* 171 */   "ellipsis",
    /* 172 */   "nonbreakingspace",
    /* 173 */   "Agrave",
    /* 174 */   "Atilde",
    /* 175 */   "Otilde",
    /* 176 */   "OE",
    /* 177 */   "oe",
    /* 178 */   "endash",
    /* 179 */   "emdash",
    /* 180 */   "quotedblleft",
    /* 181 */   "quotedblright",
    /* 182 */   "quoteleft",
    /* 183 */   "quoteright",
    /* 184 */   "divide",
    /* 185 */   "lozenge",
    /* 186 */   "ydieresis",
    /* 187 */   "Ydieresis",
    /* 188 */   "fraction",
    /* 189 */   "currency",
    /* 190 */   "guilsinglleft",
    /* 191 */   "guilsinglright",
    /* 192 */   "fi",
    /* 193 */   "fl",
    /* 194 */   "daggerdbl",
    /* 195 */   "periodcentered",
    /* 196 */   "quotesinglbase",
    /* 197 */   "quotedblbase",
    /* 198 */   "perthousand",
    /* 199 */   "Acircumflex",
    /* 200 */   "Ecircumflex",
    /* 201 */   "Aacute",
    /* 202 */   "Edieresis",
    /* 203 */   "Egrave",
    /* 204 */   "Iacute",
    /* 205 */   "Icircumflex",
    /* 206 */   "Idieresis",
    /* 207 */   "Igrave",
    /* 208 */   "Oacute",
    /* 209 */   "Ocircumflex",
    /* 210 */   "apple",
    /* 211 */   "Ograve",
    /* 212 */   "Uacute",
    /* 213 */   "Ucircumflex",
    /* 214 */   "Ugrave",
    /* 215 */   "dotlessi",
    /* 216 */   "circumflex",
    /* 217 */   "tilde",
    /* 218 */   "macron",
    /* 219 */   "breve",
    /* 220 */   "dotaccent",
    /* 221 */   "ring",
    /* 222 */   "cedilla",
    /* 223 */   "hungarumlaut",
    /* 224 */   "ogonek",
    /* 225 */   "caron",
    /* 226 */   "Lslash",
    /* 227 */   "lslash",
    /* 228 */   "Scaron",
    /* 229 */   "scaron",
    /* 230 */   "Zcaron",
    /* 231 */   "zcaron",
    /* 232 */   "brokenbar",
    /* 233 */   "Eth",
    /* 234 */   "eth",
    /* 235 */   "Yacute",
    /* 236 */   "yacute",
    /* 237 */   "Thorn",
    /* 238 */   "thorn",
    /* 239 */   "minus",
    /* 240 */   "multiply",
    /* 241 */   "onesuperior",
    /* 242 */   "twosuperior",
    /* 243 */   "threesuperior",
    /* 244 */   "onehalf",
    /* 245 */   "onequarter",
    /* 246 */   "threequarters",
    /* 247 */   "franc",
    /* 248 */   "Gbreve",
    /* 249 */   "gbreve",
    /* 250 */   "Idotaccent",
    /* 251 */   "Scedilla",
    /* 252 */   "scedilla",
    /* 253 */   "Cacute",
    /* 254 */   "cacute",
    /* 255 */   "Ccaron",
    /* 256 */   "ccaron",
    /* 257 */   "dcroat",
